// 
// ---------------------
/*
 * Keyword Highlight
 * 
 * Create by k.Hiramatsu
 * Modefiy 2015-04-14
 * 
 * 
 * ex)
 *  $(targetNome).keyHighlight(keyword, {Element:"tagName", Class:"className"});
 * 
 *  Sample:
 *     $('div#hoge').keyHighlight("hogehoge");
 *     $('div#hoge').keyHighlight("hogehoge", {
 *        "Element": "strong",        //Def: mark
 *        "Class":   "light",         //Def: ""
 *        "addID":   true,            //Def: true ID付与
 *        "scroll":  [false, "body", "html,body"],  //Def: [false, "body"] ヒットした位置にスクロール、スクロール量計算基準要素、スクロール要素
 *        "UpLo":    false,           //Def: false 大文字小文字区別
 *        "ZenHan":  false            //Def: false 全角半角区別
 *        "pMatch":  false            //Def: false 完全一致
 *     });
 * 
 * Default Element:"mark", Class:""
 * 
 */
(function(h){h.fn.keyHighlight=function(q,E){settings=h.extend({},{Element:"mark",Class:"",addID:!0,scroll:[!1,"body","html,body"],UpLo:!1,ZenHan:!1,pMatch:!1},E);settings.pMatch&&(settings.UpLo=!0,settings.ZenHan=!0);settings.pMatch||(q=h.trim(q.replace(/[\s\u3000]+/g," ")));if(q&&""!=q&&this.length){var n="\u3300\u3347\u3362\u3363\u3364\u3365\u3366\u3367\u3368\u3369\u336a\u336b\u336c\u336d\u336e\u336f\u3370".split(""),w={";":["&#59;"],"&":["&amp;","&#38;"],"<":["&lt;"],">":["&gt;"],"'":["&#39;",
"&apos;"],'"':["&quot;","&#34;"]},r=')([]{}/$#&`"_?^+*|.,-\\'.split(""),c;for(c in r)r[c]="\\"+r[c];var F=new RegExp("(["+r.join("")+"])","g"),C="a abbr acronym address applet area article aside audio b base basefont bdi bdo bgsound big blink blockquote br button canvas caption center cite code col colgroup command comment datalist dd del details dfn dir div dl dt em embed fieldset figcaption figure font footer form frame frameset h1 h2 h3 h4 h5 h6 header hgroup hr i iframe ilayer img input ins isindex kbd keygen label layer legend li link listing map mark marquee menu meta meter multicol nav nextid nobr noembed noframes nolayer noscript object ol optgroup option output p param plaintext pre progress q rb rbc rp rt rtc ruby s samp script section select server small source spacer span strike strong style sub summary sup table tbody td textarea tfoot th thead time tr track tt u ul var video wbr xmp".split(" "),
m=function(a){return a.replace(F,"\\$1")},x=function(a){return a=a.replace(RegExp("[&<>\"']","g"),function(a){return w[a][0]})},r=function(a){var b=[],e=[],f="((</?("+C.join("|")+")( [^>]*?)?>)+)",f=new RegExp("("+f+"|([^<]+))","ig");a=a.replace(/(\x3c!--.*?--\x3e)/g,"").replace(/(\s+|&nbsp;)/g," ");a=a.match(f);for(var f=0,c=a.length;f<c;f++)/^</.test(a[f])?(b.push(d[0]),e.push(a[f])):(b.push(a[f]),e.push(""));return[b,e]},G=function(){for(var a=[],b=new RegExp(d[0]),c=Math.max(e.length,y.length),
f=0;f<c;f++)b.test(e[f])?a.push(y[f]||""):a.push(e[f]||"");return a},H=function(a){if(!a)return a;var b={},e=[],d,c;for(d=0;d<a.length;d++)c=a[d],c in b||(b[c]=!0,e.push(c));return e},I=function(a){if(!a)return a;var b=[];for(c=0;c<a.length;c++)a[c]&&b.push(a[c]);return b},D=settings.UpLo?"g":"ig",J=this.length,z=0;for(;z<J;z++){var A=this[z],d=n,b=new RegExp(d.join("|"),"g"),k=h(A).html().match(b);k&&(k=new RegExp(k.join("|"),"g"),d=d.join("").replace(k,""),d=d.split(""));if(!(2>d.length)){var g=
r(h(A).html()),e=g[0],y=g[1],e=e.join(d[1]),B;for(B in w)b=new RegExp("("+w[B].join("|")+")","g"),e=e.replace(b,B);if(settings.pMatch)g=new RegExp(m(q),"g");else{b=[];g=q.split(" ");for(c in g){var t=[],l=g[c].split("");if(settings.ZenHan)for(p in l)l[p]=m(l[p]),t.push("("+l[p]+")");else for(var p in l)l[p]=l[p].replace(/[\!-\~\uff01-\uff5e\uffe5]/,function(a){return/[\uff01-\uff5e]/.test(a)?"("+a+"|"+m(String.fromCharCode(a.charCodeAt(0)-65248))+")":/[\uffe5]/.test(a)?"("+a+"|"+m(String.fromCharCode(92))+
")":/[\\]/.test(a)?"("+m(a)+"|"+String.fromCharCode(65509)+")":"("+m(a)+"|"+String.fromCharCode(a.charCodeAt(0)+65248)+")"}),t.push(l[p]);b.push(t.join("(("+d[1]+d[0]+d[1]+")*)"))}b="("+b.join("|")+")";g=new RegExp(b,D)}b=!1;b=e.match(g);if(b=I(H(b))){for(c in b)b[c]=m(b[c]);var g=new RegExp("("+b.join("|")+")",D),u=[],v=["<"+settings.Element+(settings.Class?' class="'+settings.Class+'"':"")+">","</"+settings.Element+">"],e=e.replace(g,function(a){var b=new RegExp("("+d[0]+"|"+d[1]+")");k="";if(b.test(a)){match=
a.match(new RegExp("[^"+d[0]+d[1]+"]+","ig"));k=a;for(var c in match)a=m(match[c]),k=k.replace(new RegExp(a),d[2]),u.push(v[0]+x(match[c])+v[1])}else k=d[2],u.push(v[0]+x(a)+v[1]);return k}),e=x(e),g=new RegExp(d[2]);for(c in u)e=e.replace(g,u[c])}e=e.split(d[1]);g=G().join("");h(A).html(g);delete e;delete y;delete b;delete C;l=tag=g=b=k=t=b=void 0}}settings.addID&&(n=settings.Class?"."+settings.Class:"",h(this).find(settings.Element+n).each(function(a,b){h(b).attr("id","hitMark"+a)}));settings.scroll[0]&&
(n=(n=Math.floor(h("#hitMark0").offset().top-h(settings.scroll[1]).offset().top-20))?n:0,h(settings.scroll[2]).animate({scrollTop:n},700))}}})(jQuery);
